#include <iostream>
#include <string>

#include "elevator.h"

bool humanColission(std::vector<human> humans, int n);
std::string masstring(int mass);
std::string elevatorppl(std::vector<human> in_elevator);

bool const Elevator::running() const
{
    return this->window->isOpen();
}

Elevator::Elevator()
{
    this->setup();
}

Elevator::~Elevator()
{

}
void Elevator::setup()
{
    this->window = new sf::RenderWindow(sf::VideoMode(1200, 600), "Elevator", sf::Style::Titlebar | sf::Style::Close);

    this->window->setFramerateLimit(30);

    this->window->setPosition(sf::Vector2i(250, 250));

    this->elevator_mass = 0;

    for (int i = 0; i < 6; i++)
    {
    rectangles[i].setFillColor(sf::Color::Yellow);
    rectangles[i].setSize(sf::Vector2f(500, 10));
    rectangles[i].setPosition(0, 100*i+90);

    elevator.setFillColor(sf::Color::Blue);
    elevator.setSize(sf::Vector2f(100,100));
    elevator.setPosition(500, 500);
    const sf::Color &background = sf::Color(137, 196, 244, 255);
    panelbackground.setFillColor(background);
    panelbackground.setSize(sf::Vector2f(600, 600));
    panelbackground.setPosition(600, 0);
    }

    font.loadFromFile("Fonts/Dosis-Light.ttf");
    text.setFont(font);
    text.setCharacterSize(36);
    text.setFillColor(sf::Color::Black);
    text.setString("Dodaj pasazera");
    text.setStyle(sf::Text::Bold);
    text.setPosition(600 + 10, 10);

    texture.loadFromFile("Images/arrow1.png");
    texture1.loadFromFile("Images/arrow2.png");
    texture2.loadFromFile("Images/arrow1active.png");
    texture3.loadFromFile("Images/arrow2active.png");
    arrow.setPosition(SIMWIDTH+10, 60);
    arrow.setScale(sf::Vector2f(0.1f, 0.1f));
    arrow1.setPosition(SIMWIDTH+10, 110);
    arrow1.setScale(sf::Vector2f(0.1f, 0.1f));
    arrow2.setPosition(SIMWIDTH+10, 180);
    arrow2.setScale(sf::Vector2f(0.1f, 0.1f));
    arrow3.setPosition(SIMWIDTH+10, 230);
    arrow3.setScale(sf::Vector2f(0.1f, 0.1f));
    arrow3.setColor(sf::Color::Yellow);
    value1.setFont(font);
    value1.setCharacterSize(40);
    value1.setFillColor(sf::Color::Black);
    value1.setPosition(SIMWIDTH+100, 80);
    value1.setString("Pietro poczatkowe: 0");
    value2 = value1;
    value2.setPosition(SIMWIDTH+100, 200);
    value2.setString("Pietro docelowe: 0");

    button.setFillColor(buttoncolor);
    button.setPosition(SIMWIDTH + 520, 10);
    button.setSize(sf::Vector2f(70, 70));
    elevatormove.setFont(font);
    elevatormove.setCharacterSize(36);
    elevatormove.setFillColor(sf::Color::Black);
    elevatormove.setString("Wyslij winde na pietro: ");
    elevatormove.setStyle(sf::Text::Bold);
    elevatormove.setPosition(SIMWIDTH + 10, 270);
    elevbutton1.setFillColor(this->buttoncolor);
    elevbutton1.setSize(sf::Vector2f(45, 45));
    elevbutton1.setPosition(SIMWIDTH + 45, 330);
    elevbutton2 = elevbutton3 = elevbutton4 = elevbutton5 = elevbutton6 = elevbutton1;
    elevbutton2.setPosition(SIMWIDTH + 135, 330);
    elevbutton3.setPosition(SIMWIDTH + 225, 330);
    elevbutton4.setPosition(SIMWIDTH + 315, 330);
    elevbutton5.setPosition(SIMWIDTH + 405, 330);
    elevbutton6.setPosition(SIMWIDTH + 495, 330);
    elevbutton1t.setFont(font);
    elevbutton1t.setCharacterSize(40);
    elevbutton1t.setFillColor(sf::Color::Black);
    elevbutton1t.setString(" 0");
    elevbutton1t.setStyle(sf::Text::Bold);
    elevbutton1t.setPosition(SIMWIDTH + 45, 330);
    elevbutton6t = elevbutton5t = elevbutton4t = elevbutton3t = elevbutton2t = elevbutton1t;
    elevbutton2t.setString(" 1");
    elevbutton3t.setString(" 2");
    elevbutton4t.setString(" 3");
    elevbutton5t.setString(" 4");
    elevbutton6t.setString(" 5");
    elevbutton2t.setPosition(SIMWIDTH + 135, 330);
    elevbutton3t.setPosition(SIMWIDTH + 225, 330);
    elevbutton4t.setPosition(SIMWIDTH + 315, 330);
    elevbutton5t.setPosition(SIMWIDTH + 405, 330);
    elevbutton6t.setPosition(SIMWIDTH + 495, 330);
    floor0 = elevbutton1t;
    floor1 = elevbutton2t;
    floor2 = elevbutton3t;
    floor3 = elevbutton4t;
    floor4 = elevbutton5t;
    floor5 = elevbutton6t;
    floor0.setPosition(10, 520);
    floor1.setPosition(10, 420);
    floor2.setPosition(10, 320);
    floor3.setPosition(10, 220);
    floor4.setPosition(10, 120);
    floor5.setPosition(10, 20);
    floor0.setFillColor(sf::Color::White);
    floor1.setFillColor(sf::Color::White);
    floor2.setFillColor(sf::Color::White);
    floor3.setFillColor(sf::Color::White);
    floor4.setFillColor(sf::Color::White);
    floor5.setFillColor(sf::Color::White);
    this->str = masstring(this->elevator_mass);
    masstext.setString(this->str);
    masstext.setFont(font);
    masstext.setCharacterSize(36);
    masstext.setFillColor(sf::Color::Black);
    masstext.setPosition(600 + 10, 390);
    elevator_ppl.setString(elevatorppl(in_elevator));
    elevator_ppl.setFont(font);
    elevator_ppl.setCharacterSize(36);
    elevator_ppl.setFillColor(sf::Color::Black);
    elevator_ppl.setPosition(600 + 10, 430);
    elevator_in.setString("Wpusc pasazera");
    elevator_in.setFont(font);
    elevator_in.setCharacterSize(36);
    elevator_in.setFillColor(sf::Color::Black);
    elevator_in.setPosition(600 + 10, 470);
    elevator_out.setString("Wypusc pasazera");
    elevator_out.setFont(font);
    elevator_out.setCharacterSize(36);
    elevator_out.setFillColor(sf::Color::Black);
    elevator_out.setPosition(600 + 310, 470);
    elevator_inbutton.setFillColor(buttoncolor);
    elevator_inbutton.setPosition(SIMWIDTH + 90, 520);
    elevator_inbutton.setSize(sf::Vector2f(60, 60));
    elevator_outbutton.setFillColor(buttoncolor);
    elevator_outbutton.setPosition(SIMWIDTH + 450, 520);
    elevator_outbutton.setSize(sf::Vector2f(60, 60));

    this->dest = 2; // 1 -> down, 2 -> stop, 3 -> up, 4 -> not change (in positioning function)
    this-> pressed = this->pressedM = false;
    this->counting = 0;
    this->time = 0;
    this->last_level = -1;
}

void Elevator::draw()
{
    this->window->clear();

    for(int i = 0; i < 6; i++)
        {
            this->window->draw(this->rectangles[i]);
        }
        for(int i = 0; i < this->humans.size(); i++)
        {
            this->window->draw(this->humans[i].shape);
        }

        for(int i = 0; i < this->out.size(); i++)
        {
            this->window->draw(this->out[i].shape);
        }

        this->window->draw(elevator);

        this->window->draw(panelbackground);

        this->window->draw(text);
        
        this->window->draw(arrow);
        this->window->draw(arrow1);
        this->window->draw(arrow2);
        this->window->draw(arrow3);
        this->window->draw(value1);
        this->window->draw(value2);
        this->window->draw(button);
        this->window->draw(elevatormove);
        this->window->draw(elevbutton1);
        this->window->draw(elevbutton2);
        this->window->draw(elevbutton3);
        this->window->draw(elevbutton4);
        this->window->draw(elevbutton5);
        this->window->draw(elevbutton6);
        this->window->draw(elevbutton1t);
        this->window->draw(elevbutton2t);
        this->window->draw(elevbutton3t);
        this->window->draw(elevbutton4t);
        this->window->draw(elevbutton5t);
        this->window->draw(elevbutton6t);
        this->window->draw(floor0);
        this->window->draw(floor1);
        this->window->draw(floor2);
        this->window->draw(floor3);
        this->window->draw(floor4);
        this->window->draw(floor5);
        this->window->draw(masstext);
        this->window->draw(elevator_ppl);

    this->window->display();
}

void Elevator::pollEvents()
{
        v = sf::Mouse::getPosition(*this->window);

        if (this->time >= 100) time = 1;
        else if (time >= 10) time = 0;

        x = v.x;
        y = v.y;
        static float elevdesty = 500;
        sf::Event event;
        this->window->pollEvent(event);

        static short startfloor = 0, endfloor = 0;
            if (event.type == sf::Event::Closed) 
            {
                this->window->close();
            }
            else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Escape))
            {
                this->window->close();
            }

            if (y >= 60 && y <= 100 && x >= SIMWIDTH+10 && x <= SIMWIDTH+80) 
                {
                    this->arrow.setTexture(texture2);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {   if (this->pressedM == false)
                        {
                        this->pressedM = true;
                        if(startfloor < 5) startfloor++;
                        switchstartfloor(startfloor, value1);
                        }
                    }
                }
                else this->arrow.setTexture(texture);
                if (y >= 110 && y <= 150 && x >= SIMWIDTH+10 && x <= SIMWIDTH+80)
                {
                    this->arrow1.setTexture(texture3);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {   if (this->pressedM == false)
                        {
                        this->pressedM = true;
                        if(startfloor > 0) startfloor--;
                        switchstartfloor(startfloor, value1);
                        }
                    }
                }
                else this->arrow1.setTexture(texture1);
                if (y >= 180 && y <= 220 && x >= SIMWIDTH+10 && x <= SIMWIDTH+80)
                {
                    this->arrow2.setTexture(texture2);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {   
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        if(endfloor < 5) endfloor++;
                        switchendfloor(endfloor, value2);
                        }
                    }
                }
                else this->arrow2.setTexture(texture);
                if (y >= 230 && y <= 270 && x >= SIMWIDTH+10 && x <= SIMWIDTH+80)
                {
                    this->arrow3.setTexture(texture3);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {   
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        if(endfloor > 0) endfloor--;
                        switchendfloor(endfloor, value2);
                        }
                    }
                }
                else this->arrow3.setTexture(texture1);
                if (y >= 10 && y <= 80 && x >= SIMWIDTH+520 && x <= SIMWIDTH+590)
                {
                    this->button.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                        if(this->pressedM == false)
                        {
                        this->pressedM  =true;
                        this->floor[startfloor].push(endfloor);
                        spawnHuman(startfloor, endfloor);
                        }
                    }
                }
                else this->button.setFillColor(this->buttoncolor);

                if (y >= 330 && y <= 375 && x >= SIMWIDTH+45 && x <= SIMWIDTH+90)
                {
                    this->elevbutton1.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        this->add_to_queue(0);
                        }
                    }
                }
                else this->elevbutton1.setFillColor(this->buttoncolor);
                if (y >= 330 && y <= 375 && x >= SIMWIDTH+135 && x <= SIMWIDTH+180)
                {
                    this->elevbutton2.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        this->add_to_queue(1);
                        }
                    }
                }
                else this->elevbutton2.setFillColor(this->buttoncolor);
                if (y >= 330 && y <= 375 && x >= SIMWIDTH+225 && x <= SIMWIDTH+270)
                {
                    this->elevbutton3.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        this->add_to_queue(2);
                        }
                    }
                }
                else this->elevbutton3.setFillColor(this->buttoncolor);
                if (y >= 330 && y <= 375 && x >= SIMWIDTH+315 && x <= SIMWIDTH+360)
                {
                    this->elevbutton4.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                       if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        this->add_to_queue(3);
                        }
                    }
                }
                else this->elevbutton4.setFillColor(this->buttoncolor);
                if (y >= 330 && y <= 375 && x >= SIMWIDTH+405 && x <= SIMWIDTH+450)
                {
                    this->elevbutton5.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        this->add_to_queue(4);
                        }
                    }
                }
                else this->elevbutton5.setFillColor(this->buttoncolor);
                if (y >= 330 && y <= 375 && x >= SIMWIDTH+495 && x <= SIMWIDTH+540)
                {
                    this->elevbutton6.setFillColor(sf::Color::Yellow);
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left))
                    {
                        if(this->pressedM == false)
                        {
                        this->pressedM = true;
                        this->add_to_queue(5);
                        }
                    }
                }
                else this->elevbutton6.setFillColor(this->buttoncolor);
                if(!sf::Mouse::isButtonPressed(sf::Mouse::Left)) pressedM = false;     

                this->positioning(elevdesty);          

        if(this->elevator.getPosition().y > elevdesty) dest = 3;
        else if (this->elevator.getPosition().y < elevdesty) dest = 1;
        else dest = 2;
        
        if(elevator_mass >= 560) 
        {
            if (dest == 3 && (!outers() || !q_condition())) this->elevator.move(0.f, -4.f);
            else if (dest == 1 && (!outers() || !q_condition())) this->elevator.move(0.f, 4.f);
        }
        else if(elevator_mass < 560)
        {
            if(dest == 3 && (!(!canMove() && q_condition()) ) ) this->elevator.move(0.f, -4.f);
            else if(dest == 1 && (!(!canMove() && q_condition()) )) this->elevator.move(0.f, 4.f);
        }

        //Moving humans
        for (int i = 0; i < this->humans.size(); i++)
        {
            if (this->humans[i].shape.getPosition().x <= 440 && !humanColission(this->humans, i))
            this->humans[i].shape.move(10, 0.f);
        }

        for (int i = 0; i < this->out.size(); i++)
        {
            if (this->out[i].shape.getPosition().x <= 440)
            this->out[i].shape.move(-10, 0.f);
        }

        // Entering elevator
        for (int i = 0; i < this->humans.size(); i++)
        {
            if (this->humans[i].shape.getPosition().x >= 440 && this->elevator_mass <= 530 && !canMove() && q_condition()) human_entering(i, this->str);
        }

        // Writing the passengers
        elevator_ppl.setString(elevatorppl(in_elevator));

        //Return to lvl 0 if resting
        if (elevator_mass == 0 && dest == 2)
        {
            counting+=1;
        }
        else counting = 0;
        if (counting >= 150) 
        {
            dest =1;
            elevdesty = 500;
            counting = 0;
        }

        //Escaping elevator
        if(!canMove() && elevator_mass > 0)
        {
            for(int i = 0; i < this->in_elevator.size();i++)
            {
            if(time ==0)
            human_escaping(i, this->str);
            if(time >= 100) break;
            }
        }

         //Deleting
        for (int i = 0; i < this->out.size(); i++)
        {
            if (this->out[i].shape.getPosition().x <= 0) human_delete(i); 
        }


        for (int i = 0; i < 6; i++)
        {
            if(this->elevator.getPosition().y == 500-100*i) remove_from_queue(i);
        }

        time++;
}

void Elevator::add_to_queue(int n)
{
    bool already_is = false;
    for (int i = 0; i < this->queue1.size(); i++)
    {
        if (this->queue1[i] == n) already_is = true;
    }
    if(!already_is) this->queue1.push_back(n);
    
}

void Elevator::remove_from_queue(int n)
{
    for (int i = 0; i < this->queue1.size(); i++)
    {
        if (this->queue1[i] == n) 
        {
            this->last_level = this->queue1[i];
            this->queue1.erase(this->queue1.begin()+i);
        }
    }  
}

void Elevator::positioning(float &elevdesty)
{
    int dest1 = 0;
    bool up, down;
    up = down = false;
    if (this->queue1.size()==0) 
    {
        up = down = false;
        this->dest = 4;
        }
    else if (this->queue1[0] > (500-this->elevator.getPosition().y)/100) down = true;
    else if (this->queue1[0] < (500-this->elevator.getPosition().y)/100) up = true;
    else up = down = false;

    if (up && this->queue1.size()>0) dest1 = *min_element(this->queue1.begin(), this->queue1.end()); 
    else if (down && this->queue1.size()>0) dest1 = *max_element(this->queue1.begin(), this->queue1.end());

    if(dest != 4)elevdesty = 500 -dest1*100;
}

bool Elevator::canMove()
{
    for (int i = 0; i < humans.size(); i++)
    {
        if(humans[i].start_level == (500-this->elevator.getPosition().y)/100) return false;
    }
    for (int i = 0; i < in_elevator.size(); i++)
    {
        if(in_elevator[i].end_level == (500-this->elevator.getPosition().y)/100) return false;
    }
    return true;
}

bool Elevator::in_q()
{
    for (int i = 0; i < queue1.size(); i++)
    {
        if (queue1[i] == (500- this->elevator.getPosition().y)/100) return true;
    }
    return false;
}


bool Elevator::q_condition()
{
    if ( ((500- this->elevator.getPosition().y)/100==0 && last_level== -1) || (500- this->elevator.getPosition().y)/100 == this->last_level ) return true;
    else return false;
}
bool Elevator::outers()
{
    for (int i = 0; i < in_elevator.size(); i++)
    {
        if(in_elevator[i].end_level == (500-this->elevator.getPosition().y)/100) return true;
    }
    return false;
}
void Elevator::switchstartfloor(short a, sf::Text& text)
{
    switch (a)
        {
        case 0:
            text.setString("Pietro poczatkowe: 0");
            break;
        case 1:
            text.setString("Pietro poczatkowe: 1");
            break;
        case 2:
            text.setString("Pietro poczatkowe: 2");
            break;
        case 3:
            text.setString("Pietro poczatkowe: 3");
            break;
        case 4:
            text.setString("Pietro poczatkowe: 4");
            break;
        case 5:
            text.setString("Pietro poczatkowe: 5");
            break;
        default:
            break;
        }
}

void Elevator::switchendfloor(short a, sf::Text& text)
{
    switch (a)
        {
        case 0:
            text.setString("Pietro docelowe: 0");
            break;
        case 1:
            text.setString("Pietro docelowe: 1");
            break;
        case 2:
            text.setString("Pietro docelowe: 2");
            break;
        case 3:
            text.setString("Pietro docelowe: 3");
            break;
        case 4:
            text.setString("Pietro docelowe: 4");
            break;
        case 5:
            text.setString("Pietro docelowe: 5");
            break;
        default:
            break;
        }
}

void Elevator::spawnHuman(int n, int d)
{
    if(this->humans.size()<20){
    human human;

    human.shape.setFillColor(sf::Color::Red);
    human.shape.setSize(sf::Vector2f(50,50));

    human.end_level = d;
    
    switch (n)
    {
        case 5: 
            human.start_level = 5;
            human.shape.setPosition(0, 40);
            break;
        case 4: 
            human.start_level = 4;
            human.shape.setPosition(0, 140);
            break;
        case 3: 
            human.start_level = 3;
            human.shape.setPosition(0, 240);
            break;
        case 2: 
            human.start_level = 2;
            human.shape.setPosition(0, 340);
            break;
        case 1: 
            human.start_level = 1;
            human.shape.setPosition(0, 440);
            break;
        case 0: 
            human.start_level = 0;
            human.shape.setPosition(0, 540);
            break;
    }

    this->humans.push_back(human);
    }
}

void Elevator::human_entering(int n, std::string str)
{ 

    if (this->humans[n].start_level == (500-this->elevator.getPosition().y)/100 && !canMove())
    {
    this->in_elevator.push_back(humans[n]);
    this->humans.erase(humans.begin() + n);
    this->elevator_mass += 70;
    str = masstring(this->elevator_mass);
    this->masstext.setString(str);
    }
}

void Elevator::human_escaping(int n, std::string str)
{
    if(this->in_elevator[n].end_level == (500-this->elevator.getPosition().y)/100 && !canMove())
    {
        this->out.push_back(this->in_elevator[n]);
        this->out[this->out.size()-1].shape.setFillColor(sf::Color::Blue);
        this->out[this->out.size()-1].shape.setPosition(440, 500-this->in_elevator[n].end_level*100);
        this->in_elevator.erase(this->in_elevator.begin()+n);
        this->elevator_mass-=70;
        this->time = 100;
        str = masstring(this->elevator_mass);
        this->masstext.setString(str);
    }
    else this->time = 0;
}

void Elevator::human_delete (int n)
{
    this->out.erase(this->out.begin() + n);
}

bool humanColission(std::vector<human> h, int n)
{ 
    for (int i = 0; i < h.size(); i++)
    {
        if (i < n && h[n].start_level == h[i].start_level &&  h[i].shape.getPosition().x  <= h[n].shape.getPosition().x + 60) return true;
    }
    return false;

}

std::string masstring(int mass)
{
    std::string str1, str2, smass, str;
    smass = std::to_string(mass);
    str1 = "Obciazenie windy wynosi: ";
    str2 = " kg";
    str = str1 + smass + str2;
    return str;
}

std::string elevatorppl(std::vector<human> in_elevator)
{
    std::string str1 = "Pasazerowie windy: ";
    for(int i = 0; i < in_elevator.size(); i++) 
    {
        str1 = str1 + std::to_string(in_elevator[i].end_level);
        str1 = str1 + ", ";
    }
    return str1;
}
