#include <SFML/Graphics.hpp>
#include <SFML/System.hpp>
#include <SFML/Window.hpp>
#include <SFML/Audio.hpp>
#include <SFML/Network.hpp>

#include<vector>
#include <queue>

#include <sstream>
#include <string>

struct human
{
    int start_level;
    int end_level;
    sf::RectangleShape shape;
};

const int SIMWIDTH = 600;

class Elevator
{
    private:
    sf::RenderWindow* window;
	sf::Event ev;

    sf::RectangleShape rectangles[6];
     sf::RectangleShape elevator;
     sf::RectangleShape panelbackground;

    std::vector<human> humans;
    std::vector<human> in_elevator;
    std::vector<human> out;
    std::queue<short> floor[6];
    std::string str, elevator_string;

    std::vector<int> queue1;

    sf::Font font;
    sf::Text text, value1, value2, elevatormove, elevbutton1t, elevbutton2t, elevbutton3t, elevbutton4t, elevbutton5t, elevbutton6t, floor0, floor1, floor2, floor3, floor4, floor5, masstext, elevator_ppl, elevator_in, elevator_out;

    sf::Texture texture, texture1, texture2, texture3;
    sf::Sprite arrow, arrow1, arrow2, arrow3;

    sf::RectangleShape button, elevbutton1, elevbutton2, elevbutton3, elevbutton4, elevbutton5, elevbutton6, elevator_inbutton, elevator_outbutton;
    const sf::Color buttoncolor = sf::Color(0, 148, 0, 255);
    
    sf::Vector2i v;
    int x, y;

    int counting;
    int time;

    int last_level;

    int dest;
    bool pressed, pressedM;

    int elevator_mass;

    void setup();

    public:

        Elevator();
        ~Elevator();

        bool const running() const;

        void draw();
        void pollEvents();

        void add_to_queue(int n);
        void remove_from_queue(int n);
        void positioning(float &elevdesty);
        bool canMove();
        bool in_q();
        bool q_condition();
        bool outers();
        void spawnHuman(int n, int d);
        void human_entering(int n, std::string str);
        void human_escaping(int n, std::string str);
        void human_delete(int n);

        void switchendfloor(short a, sf::Text& text);
        void switchstartfloor(short a, sf::Text& text);
};
